
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【外传】——Attribute Routing / iVAN</title>

    <meta name="description" content="使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【外传】——Attribute Routing 原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[外传]--Attribute Routing 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 题外话:由于这个技术点是新学的,并不属于原系列,但借助了原系列的项目背景,故命名外传系列,以后也可能在这个系列中附加一些新的技术. 前言 在Web Api 2.0中,提出了一种新的配置路由方式--基于特性的路由(Attribute-based Routing),在我们之前">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【外传】——Attribute Routing</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/fzrain/p/3591040.html" rel="external nofollow noreferrer">使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【外传】——Attribute Routing</a><br />
<br />系列导航地址<a href="http://www.cnblogs.com/fzrain/p/3490137.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fzrain/p/3490137.html</a></p>
<p>题外话：由于这个技术点是新学的，并不属于原系列，但借助了原系列的项目背景，故命名外传系列，以后也可能在这个系列中附加一些新的技术。</p>
<p>前言</p>
<p>在Web Api 2.0中，提出了一种新的配置路由方式——基于特性的路由（Attribute-based Routing），在我们之前介绍的配置路由方式称为——基于公约的路由（Convention-based Routing），新的路由配置方式同样应用在MVC5中，因此本文就来介绍一下基于特性的路由。</p>
<p>在之前的一篇文章中，我们处理了这么一个业务——实现学生选课。我们是通过在“WebApiConfig”定制了一条路由数据来实现的，这条路由实现了选课以及根据课程Id来查询选择选择该课程的所有学生信息，感觉设计还可以。在实际应用中一般来说查询用的是最多的，使用Attribute Routing来注册路由会更灵活，控制起来也更方便，更符合Rest。本文以根据课程的名字来查询所有选择该课程的学生信息以及根据课程名字以及学生名字查询某一学生的信息。</p>
<p>基于特性的路由介绍</p>
<p>顾名思义，新路由将使用一个特性来实现路由注册，如下：</p>
<pre>[AttributeUsage(AttributeTargets.Method | AttributeTargets.Class, AllowMultiple=true, Inherited=true)]
    public sealed class RouteAttribute : Attribute, IHttpRouteInfoProvider
    {
        public RouteAttribute();
        public RouteAttribute(string template);

        public string  Name { get; set; }
        public int     Order { get; set; }
        public string  Template { get; private set; }
    }</pre>
<p>这个类包含3个属性：Name指路由的名字，Order是指路由的顺序，Template就是我们要去匹配URL的模板</p>
<p>实现Attribute Routing</p>
<p>原理性的东西不多介绍的（我也没多研究 呵呵），能把学到的技术运用到实际中才是王道，上来一大堆原理容易晕，以后需要深入研究再看原理。</p>
<p>在“EnrollmentsController”中新增一个方法GetStudentsInfo：</p>
<pre>[Route("api/enrollments/{courseName}/{studentName?}")]
        public IEnumerable&lt;StudentBaseModel&gt; GetStudentsInfo(string courseName, string studentName="")
        {
            IQueryable&lt;Student&gt; query;
            Course course=  TheRepository.GetAllCourses().Where(c =&gt; c.Name == courseName).FirstOrDefault();
            if (course==null )
            {
                return null ;
            }
             query = TheRepository.GetEnrolledStudentsInCourse(course.Id).OrderBy(s =&gt; s.LastName);
            if (!string.IsNullOrWhiteSpace(studentName))
            {
                query = query.Where(s =&gt; s.FirstName == studentName);
            }
            var totalCount = query.Count();

            System.Web.HttpContext.Current.Response.Headers.Add("X-InlineCount", totalCount.ToString());

            var results = query

                        .ToList()
                        .Select(s =&gt; TheModelFactory.Create(s));

            return results;

        }</pre>
<p>在我们的Action上使用了RouteAttribute。分析一下这个URL模板（"api/enrollments/{courseName}/{studentName?}"），{courseName}会匹配到Action的courseName参数上，对于Action的另一个参数studentName是一个可选参数，也就是说请求中没有给出值那么就是默认的空字符串，有值得话就会被赋值，因此我们在“{studentName}”后面加上？ 标记为可选的URI参数。</p>
<p>ok,就这么简单，测试一次：</p>
<p><a href="http://images.cnitblog.com/blog/532802/201403/100823309541646.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ183NTFlOGJlOGNjYmQxN2RjMzVmYjQ5MzNkZTgzNjUyZS5wbmc=.jpg"></a></p>
<p>结果：</p>
<p><a href="http://images.cnitblog.com/blog/532802/201403/100823317515002.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kNWJlODlmNTIwMTdlYjBiMmU1MTZlN2M4NDQ3MGFiNi5wbmc=.jpg"></a></p>
<p>呃，出错了。。。</p>
<p>一个新的问题</p>
<p>出错了，不过不管怎么说解决方案总归是有的，首先看下错误原因：是在LearningControllerSelector类的方法中出现了空引用，那么我们就不得不看下这个方法：</p>
<pre>public override HttpControllerDescriptor SelectController(HttpRequestMessage request)
        {
            var controllers = GetControllerMapping(); //Will ignore any controls in same name even if they are in different namepsace

            var routeData = request.GetRouteData();

            var controllerName = routeData.Values["controller"].ToString();

            HttpControllerDescriptor controllerDescriptor;

            if (controllers.TryGetValue(controllerName, out controllerDescriptor))
            {

                var version = "2";

                var versionedControllerName = string.Concat(controllerName, "V", version);

                HttpControllerDescriptor versionedControllerDescriptor;
                if (controllers.TryGetValue(versionedControllerName, out versionedControllerDescriptor))
                {
                    return versionedControllerDescriptor;
                }

                return controllerDescriptor;
            }

            return null;

        }</pre>
<p>看了这段代码我们不难发现这个方法是我们重写了基类的方法，目的是为了实现现版本控制（详情可移步：<a href="http://www.cnblogs.com/fzrain/p/3558765.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fzrain/p/3558765.html</a>），在我们重写的方法中我们用到了RouteData中包含的Controller的名字，而这个名字是由基于公约的路由与URI匹配得到的，因此我们这里肯定是没有的。因为我们的项目混合了2钟路由配置，而自定义的方法是针对基于公约的路由配置，因此对于Attribute Routing我们直接使用默认的选择方式：</p>
<p>在“var controllerName = routeData.Values["controller"].ToString(); ”代码之前加一个判断：</p>
<pre>if (string.IsNullOrWhiteSpace(routeData.Route.RouteTemplate))
            {
               return   base.SelectController(request);
            }</pre>
<p>再次请求就会得到如下结果：</p>
<p><a href="http://images.cnitblog.com/blog/532802/201403/100823325325130.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ183NGE3ZDM5ZmMxN2QyMTdlNzM2YzYzYWM5YzQ1MDllZC5wbmc=.jpg"></a></p>
<p>结果正确，解决方案感觉还可以再考虑考虑，大家有什么好的建议可以提。但是不管怎么说，有一点是明确的：对于基于特性的路由规则，不需要包含Controller的名字，在本案列中感觉上是寻找Acton上的路由模板来匹配请求的URI，然后确定对应的Action。</p>
<p>总结</p>
<p>基于特性路由（Attribute Routing）是一种新的定制路由规则方式，与传统的配置方式相比更灵活，但同时比较分散，在web api中，2钟路由配置方式可以共存，所以本文只是介绍一种新的配置方式，做项目时也可以多一种选择。</p>
<p>本文参考相关链接：<a href="http://www.cnblogs.com/aehyok/p/3449851.html" rel="external nofollow noreferrer">http://www.cnblogs.com/aehyok/p/3449851.html</a></p>
<p>                      <a href="http://www.cnblogs.com/artech/p/attribute-routing-01.html" rel="external nofollow noreferrer">http://www.cnblogs.com/artech/p/attribute-routing-01.html</a></p>
<p>源码地址：<a href="https://github.com/fzrain/WebApi.eLearning" rel="external nofollow noreferrer">https://github.com/fzrain/WebApi.eLearning</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 22:16:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/asp/" title="asp">asp</a>, <a href="https://www.iamivan.net/tag/web/" title="web">web</a>, <a href="https://www.iamivan.net/tag/request/" title="request">request</a>, <a href="https://www.iamivan.net/tag/api/" title="api">api</a>, <a href="https://www.iamivan.net/tag/rest/" title="REST">REST</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【外传】——Attribute Routing的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40R1jz.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【四】&mdash;&mdash;实现模型工厂，依赖注入以及格式配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[四]--实现模型工厂,依赖注入以及格式配置 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 在上一篇中,我们已经初步开始使用Web Api了,但同时出现了一些很多不足之处,本章我们就着重来解决这些不足. 上篇导航:http://www.cnblogs.com/fzrain/p/3510035.html 配置JSON的格式 Web Api提供Xml和JSON作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKaOAz.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【十】&mdash;&mdash;使用CacheCow和ETag缓存资源</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[十]--使用CacheCow和ETag缓存资源 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 本文将使用一个开源框架CacheCow来实现针对Http请求资源缓存,本文主要介绍服务器端的缓存. 使用缓存技术可以很好的提高Web Api的性能,减小服务器的开销.我们把这种缓存形式称之为:条件化请求(Conditional Requests).具体表现为:客户			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Zaxrp.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【开篇】【持续更新中。。。】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[开篇][持续更新中...] 最近发现web api很火,园内也有各种大神已经在研究,本人在asp.net官网上看到一个系列教程,原文地址:http://bitoftech.net/2013/11/25/detailed-tutorial-building-asp-net-web-api-restful-service/.于是打算跟着学一下,把学习过程记录在博客园的同时也分享给大家. 每一篇结束后我都会把代码共享 由于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YAY3z.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【三】&mdash;&mdash;Web Api入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[三]--Web Api入门 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 经过前2节的介绍,我们已经把数据访问层搭建好了,从本章开始就是Web Api部分了.在正式开始之前,再一次回顾一下Web Api的应用场景:Web Api可以与 MVC,WebForm结合使用,也可以作为一个单独的Web服务.在正式讨论Web Api的配置以及如何构造我们的URI来消			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1kRxb.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【七】&mdash;&mdash;实现资源的分页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[七]--实现资源的分页 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 这篇文章我们将使用不同的方式实现手动分页(关于高端大气上档次的OData本文暂不涉及,但有可能会在系列的后期介绍,还没确定...),对于分页的结果,我们将采用2种不同的方式响应给客户端(1.将分页元数据封装在响应Body中2.在http响应报文头部添加分页信息). 众所周知,在服务器端一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdvWexb.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【五】&mdash;&mdash;在Web Api中实现Http方法&lpar;Put&comma;Post&comma;Delete&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[五]--在Web Api中实现Http方法(Put,Post,Delete) 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 在Web Api中,我们对资源的CRUD操作都是通过相应的Http方法来实现--Post(新增),Put(修改),Delete(删除),Get(查询).查询在前几章我们已经实现了,本章就在我们的案列(CourseController)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdB2R6b.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【六】&amp;amp&semi;mdash&semi;&amp;amp&semi;mdash&semi;实现资源间的关联</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[六]--实现资源间的关联 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 这一篇文章主要介绍一下资源间的关联--例如在学生和课程之间就存在这样的关联:每一个课程都会有多个学生来选,如何获取这些有关联的信息?如何实现选课的业务?对于客户端应该怎么来调用呢?下面给出解决方案: 配置对应的路由 对于上面的需求,我们可以先定制一个URI模板:&quot;api/courses			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9WE4dz.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【八】&mdash;&mdash;Web Api的安全性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[八]--Web Api的安全性 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 这一篇文章我们主要来探讨一下Web Api的安全性,到目前为止所有的请求都是走的Http协议(http://),因此客户端与服务器之间的通信是没有加密的.在本篇中,我们将在&quot;StudentController&quot;中添加身份验证功能--通过验证用户名与密码来判断是否是合法用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6e4WWb.html" rel="bookmark">通过Knockout&period;js &plus; ASP&period;NET Web API构建一个简单的CRUD应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				较之面向最终消费者的网站,企业级Web应用对用户体验的要求要低一些.不过客户对&quot;用户体验&quot;的要求是&quot;与日俱增&quot;的,很多被&quot;惯坏了&quot;的用户已经不能忍受Postback带来的页面刷新,所以Ajax在企业级Web应用中得到了广泛的应用.企业级Web应用的一个特点是以&quot;数据处理&quot;为主,所以&quot;面向绑定&quot;的Knockout.js 是一个不错的选择.ASP.NET Web API,作为.NET平台最好的REST服务开发平			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdRR2b.html" rel="bookmark" class="title">ado-&lowbar;bstr&lowbar;t，很想知道这个类型是怎么打印出来的</a>
					<div>
						问题描述 _bstr_t,很想知道这个类型是怎么打印出来的 printf((_bstr_t)(m_pRec-&gt;Fields-&gt;GetItem((long)i)-&gt;GetName()) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6AyWb.html" rel="bookmark" class="title">Frontpage2000中文教程：第四章 Frontpage2000也疯狂（2）</a>
					<div>
						frontpage|教程|中文 接下来我们学习制作动态的按纽.什么是动态按纽?你有没有看过别人的网页上有一种按纽,把鼠标移上去的时候它就会变色的的那种,那就是动态按纽了.它在Frontpage2000 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy7ldz.html" rel="bookmark" class="title">利用asp连接远端Oracle数据库方法！</a>
					<div>
						oracle|数据|数据库 首先在Oracle安装目录下networkADMIN文件夾下找到tnsnames.ora設置.如配置如下(SERVICE_NAME要注明清楚,8i以下版本是SID)︰ 假设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7JYWM.html" rel="bookmark" class="title">PS合成浪漫的蓝色调海边艺术照教程</a>
					<div>
						为Photoshop数码后期调色实例教程,教程讲解了如何运用PS调出海边婚纱浪漫蓝色调,主要学习应用图像.蒙板.色阶.替换颜色以及曲线的运用,希望朋友们喜欢~~ 谢谢黄健老师提供的原片片和效果图 我从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKBY8M.html" rel="bookmark" class="title">php实现数组按指定KEY排序的方法</a>
					<div>
						 这篇文章主要介绍了php实现数组按指定KEY排序的方法,涉及php操作数组排序的技巧,具有一定参考借鉴价值,需要的朋友可以参考下     本文实例讲述了php实现数组按指定KEY排序的方法.分享给大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKl86M.html" rel="bookmark" class="title">php实现每个ip每天投票一次的方法</a>
					<div>
						 下面是实现的代码: &lt;?php   /**  * PHP+MySQL  * CREATE TABLE IF NOT EXISTS `ip_poll` (  * `ip` varchar(15) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7j8db.html" rel="bookmark" class="title">认识win7系统强大的安全功能</a>
					<div>
						  1.Kernel Patch:系统级的安全平台的一个亮点就是kernel patch,它可以阻止对进程列表等核心信息的恶意修改,这种安全保护这只有在操作系统能实现,其他杀毒软件是无法实现的. 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywle8z.html" rel="bookmark" class="title">Java调用&period;Net的web service的几种方式</a>
					<div>
						最近做项目,涉及到web-service调用,现学了一个星期,现简单的做一个小结.下面实现的是对传喜物流系统(http://vip.cxcod.com/PodApi/GetPodStr.asmx?ws ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Ey53M.html" rel="bookmark" class="title">智能钱包Lemon 做你的财务管家</a>
					<div>
						近日,据搜狐报道,钱包不见了,任谁都会心急如焚,日前推出的一款叫做Lemon的智能钱包将能帮助你解决这个问题,让你不用在为钱包丢失而过于担心. Lemon的智能钱包能够把你的iPhone变成你钱包的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqNrkb.html" rel="bookmark" class="title">Oracle坏块问题处理 Oracle坏块修复 Oracle坏块怎么办</a>
					<div>
						Oracle数据库出现坏块现象是指:在Oracle数据库的一个或多个数据块(一个数据块的容量在创建数据库时由db_block_size参数指定,缺省为8K)内出现内容混乱的现象.由于正常的数据块都有固 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA76wZz.html" rel="bookmark" class="title">一个基于Maven的配置文件管理成功案例</a>
					<div>
						引言 配置文件几乎是每个项目中不可或缺的文件类型之一,常用的配置文件类型有xml.properties等,配置文件的好处不言而喻,利用配置文件可以灵活地设置软件的运行参数,并且可以在更改配置文件后在不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2drXb.html" rel="bookmark" class="title">测试spark集群入门级wordcount出错，求大神们帮忙解决啊</a>
					<div>
						问题描述 测试spark集群入门级wordcount出错,求大神们帮忙解决啊 Created by jyq on 10/14/15.*/就这么点源代码 import org.apache.spark. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZd8Nb.html" rel="bookmark" class="title">mfc-MFC一个关于自动滚动文本框的问题</a>
					<div>
						问题描述 MFC一个关于自动滚动文本框的问题 在VCMFC中,向文本框追加文本文字,如何自动滚动文本框保持显示最后一行呢? 解决方案 m_edit.LineScroll(m_edit.GetLineC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWxm1p.html" rel="bookmark" class="title">性价比神器！99元一年的阿里云256MB高性能Redis性能测试及应用介绍</a>
					<div>
						介绍 Redis是一个开源的key-value类型的数据库缓存和存储系统,同时Redis提供了丰富的数据结构用来支持多样的业务chan场景,比如hashes,lists,sets还有ordered s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKqqBb.html" rel="bookmark" class="title">files-dev c&plus;&plus;初学问题，求教</a>
					<div>
						问题描述 dev c++初学问题,求教 编译了helloworld.c的程序,语法没问题 接触结果出现了 C:UsersAdministratorDesktopg++.exe FilesDev-Cpp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKG76b.html" rel="bookmark" class="title">验证码显示在图片的问题</a>
					<div>
						问题描述 我写了一个方法当第一次注册的时候生成的验证码是对的,但是再来一次注册时的时候,新生成的验证码就不显示在图片上,图片上依然显示的是上次注册时生成的验证码,导致一直提示验证码不正确,不知道是怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKaRDb.html" rel="bookmark" class="title">好编辑是如何炼成的</a>
					<div>
						摘要: 上周领导通过关系让我参加了一个知名门户网站的内部分享活动,主题是&lt;好编辑是如何炼成的&gt;.听完分享会后,对我帮助挺大的,做了很多笔记,领导让我回来后再和鳄鱼组分享, 上周领导通过关系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA2lob.html" rel="bookmark" class="title">【C&sol;C&plus;&plus;】数组越界</a>
					<div>
						在上篇中说到了内存问题,今天我也遇到了可以用内存映射来解释的问题.代码如下: #include&lt;iostream&gt; using namespace std; void main() { i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZn8ep.html" rel="bookmark" class="title">【云计算的1024种玩法】用ECS搭建个人云笔记服务</a>
					<div>
						前言 互联网科技这东西发展的真**的快,一会儿不了解就给你整出一个新概念了.做做笔记就很有必要,不过是笔记那肯定是要备份的,那么云笔记本就会很方便了.但是!笔记本肯定会大量的引用到图片和视频,这时候我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQqrKp.html" rel="bookmark" class="title">1U入门级机架式服务器 HP QY389A售5800元</a>
					<div>
						HP ProLiant DL120 G7(QY389A)是一款1U入门级机架式服务器,成本较低,但是性能很高,它搭载奔腾双核处理器,双线程3MB三级缓存,Intel C200主板芯片组,最大http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvJAPM.html" rel="bookmark" class="title">Android监听来电和去电的实现方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android监听来电和去电的实现方法.分享给大家供大家参考,具体如下: 要监听android打电话和接电话,只需下面2步骤 第一步,写一个Receiver继承自BroadcastRec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q8JRp.html" rel="bookmark" class="title">PHP获取当前页面URL函数实例&lowbar;php技巧</a>
					<div>
						本文实例讲述了PHP获取当前页面URL函数实例,分享给大家供大家参考.具体实现方法如下: 在PHP中,没有默认的Function来获取目前所在页面的URL,所以今天就向大家介绍一个在PHP获取当前页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkLdKM.html" rel="bookmark" class="title">简单实现js选项卡切换效果&lowbar;javascript技巧</a>
					<div>
						本文实例介绍了实现js选项卡切换效果的详细代码,分享给大家供大家参考,具体内容如下 思路:    1.获取元素:    2.for循环按钮元素添加onclick(点击) 或者 onmousemove( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLBRBM.html" rel="bookmark" class="title">JPA框架比较</a>
					<div>
						作者 James Kao 发布于 2008年1月16日 上午1时39分   java.net刊登了一篇由Sharad Acharya所写的名为Java Persistence Framework: W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8N4r4b.html" rel="bookmark" class="title">国资委：央企须交金融衍生品季报</a>
					<div>
						[本报北京新闻中心记者李雪颖9日电]金融海啸中,央企投资海外金融衍生品的巨亏仍让人心有余悸.国资委日前下发通知,要求中央企业上报金融衍生品季报,包括持仓规模.资金使用.盈亏等具体内容. 资料显示,20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWB8qM.html" rel="bookmark" class="title">typeScript</a>
					<div>
						TypeScript 是Es6超集,es6代码都是可以编译的TypeScript代码如图所示typescript:类型 注解es6 :类 ,模块Typescript相对于es5的五大改善 1,类型 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqOPVp.html" rel="bookmark" class="title">边缘计算将蚕食云计算&comma;可能吗？</a>
					<div>
						随着越来越多的工作负载被放置于云端,一些企业为了实现转型开始向云迁移,云计算正在蚕食传统数据中心市场.据观察,目前越来越多的工作负载.数据.处理和业务价值更倾向于使用边缘计算.在这一趋势下,边缘计算可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBy9P9z.html" rel="bookmark" class="title">android中对于activity对象的困惑&lpar;新手问题&rpar;</a>
					<div>
						问题描述 1. activity对象什么时候被创建,什么时候被销毁? 请说的形象一些2. activity里的onCreate方法什么时候执行,会被执行几次?3. 如果界面布局中有文本框,我们一般会为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenAP7b.html" rel="bookmark" class="title">模板引擎smarty工作原理以及使用示例&lowbar;php模板</a>
					<div>
						模板引擎是用于把模板文件和数据内容合并在一起的程序,便于网站开发有利于代码分离和维护,了解一个模板最好知道其工作原理,以便于实现一通万通. 模板文件一般是HTML xml js等类型文件,如果不用模板 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvnG6M.html" rel="bookmark" class="title">iPhone新版持续受到移动互联网业内关注</a>
					<div>
						信息早报 郭新 近日以&quot;早晚报+即时新闻&quot;为主打的搜狐新闻客户端iPhone新版持续受到移动互联网业内关注,并在苹果App Store上受到大量果粉追捧,上线24小时之后即蹿升至新 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
